// Creating and then deleting a cyclic DLL.
// no data

#ifdef PREDATOR
# include <verifier-builtins.h>
//# define __VERIFIER_plot(a) if(__VERIFIER_nondet_bool()) __VERIFIER_plot(a)
# define __VERIFIER_plot(a) 
#else
# define __VERIFIER_plot(a) 
#endif
#include <stdlib.h>

#define DLL_NEW(type) \
    ((type *) malloc(sizeof(type)))

typedef struct dll_item dll_item_t;

struct dll_item {
    dll_item_t  *next;
    dll_item_t  *prev;
};

// head on stack
//#define CDLL_CREATE(list)       \
    struct dll_item _list;	\
    list = &_list;	\
    list->next = list;	        \
    list->prev = list;

// head on heap
#define CDLL_CREATE(list)       \
do {	                        \
    list = DLL_NEW(dll_item_t);	\
    list->next = list;	        \
    list->prev = list;	        \
}while(0)

#define CDLL_ADD(list)          \
do {	                        \
    dll_item_t *item = DLL_NEW(dll_item_t);	\
    item->next = list;	        \
    item->prev = list->prev;	\
    list->prev->next = item;	\
    list->prev = item;	        \
}while(0)

#if 0
// SLL like destroy - no match
#define CDLL_DESTROY(list)      \
do {	                        \
    dll_item_t *ref = list->prev;	\
    while (list != ref) {	\
        list = list->next;	\
        free(list->prev);	\
    }	                        \
    free(ref);	                \
}while(0)
#else
// full pop_front implemented
#define CDLL_DESTROY(list)      \
do {	                        \
    dll_item_t *ref = list->prev;	\
    while (list != ref) {	\
        dll_item_t *x = list;	\
        list = list->next;	\
        list->prev = ref;	\
        ref->next = list;	\
        free(x);	        \
    }	                        \
    free(ref);	                \
}while(0)
#endif

int main()
{
    dll_item_t *list;
    CDLL_CREATE(list);
    __VERIFIER_plot("01-cyclic-dll-base");
    CDLL_ADD(list); __VERIFIER_plot("02-cyclic-dll-add");
//    CDLL_ADD(list); __VERIFIER_plot("02-cyclic-dll-add");
//    CDLL_ADD(list); __VERIFIER_plot("02-cyclic-dll-add");
    int i;
    for (i = 0; i<10; ++i)
        CDLL_ADD(list);
    __VERIFIER_plot("03-cyclic-dll-end");
    CDLL_DESTROY(list);
    return list!=NULL;
}

/**
 * inspired by predator test: test-0060.c
 */
